summaryrefslogtreecommitdiffstats
path: root/development
diff options
context:
space:
mode:
author Johannes Schoepfer2024-04-19 16:57:09 +0200
committer Willy Sudiarto Raharjo2024-04-27 04:28:30 +0200
commit67d25cdc33a5e99c058b5107ffe4948fcf775281 (patch)
tree0b06928ede2f5465742538de34bb6f51a170cb00 /development
parentb54ef15d18e7d18d23d2d4d5df04714ee6937a2c (diff)
downloadslackbuilds-67d25cdc33a5e99c058b5107ffe4948fcf775281.tar.gz
development/stablediffusion-pipelines-cpp: Added (C++ library).
Signed-off-by: Andrew Clemons <andrew.clemons@gmail.com> Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'development')
-rw-r--r--development/stablediffusion-pipelines-cpp/README4
-rw-r--r--development/stablediffusion-pipelines-cpp/slack-desc19
-rw-r--r--development/stablediffusion-pipelines-cpp/stablediffusion-pipelines-cpp.SlackBuild112
-rw-r--r--development/stablediffusion-pipelines-cpp/stablediffusion-pipelines-cpp.info10
4 files changed, 145 insertions, 0 deletions
diff --git a/development/stablediffusion-pipelines-cpp/README b/development/stablediffusion-pipelines-cpp/README
new file mode 100644
index 0000000000..96571cfe2e
--- /dev/null
+++ b/development/stablediffusion-pipelines-cpp/README
@@ -0,0 +1,4 @@
+A set of Stable Diffusion pipelines (and related utilities) ported
+entirely to C++ (from python), with easy-to-use API’s and a focus on
+minimal third-party dependencies. The core stable-diffusion libraries
+built by this project only have dependencies on OpenVINO.
diff --git a/development/stablediffusion-pipelines-cpp/slack-desc b/development/stablediffusion-pipelines-cpp/slack-desc
new file mode 100644
index 0000000000..815c308afa
--- /dev/null
+++ b/development/stablediffusion-pipelines-cpp/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+stablediffusion-pipelines-cpp: stablediffusion-pipelines-cpp (Stable Diffusion Pipelines forOpenVINO)
+stablediffusion-pipelines-cpp:
+stablediffusion-pipelines-cpp: A set of Stable Diffusion pipelines (and related utilities) ported
+stablediffusion-pipelines-cpp: entirely to C++ (from python), with easy-to-use APIs and a focus on
+stablediffusion-pipelines-cpp: minimal third-party dependencies. The core stable-diffusion libraries
+stablediffusion-pipelines-cpp: built by this project only have dependencies on OpenVINO.
+stablediffusion-pipelines-cpp:
+stablediffusion-pipelines-cpp:
+stablediffusion-pipelines-cpp:
+stablediffusion-pipelines-cpp: https://github.com/intel/stablediffusion-pipelines-cpp
+stablediffusion-pipelines-cpp:
diff --git a/development/stablediffusion-pipelines-cpp/stablediffusion-pipelines-cpp.SlackBuild b/development/stablediffusion-pipelines-cpp/stablediffusion-pipelines-cpp.SlackBuild
new file mode 100644
index 0000000000..8059d3486a
--- /dev/null
+++ b/development/stablediffusion-pipelines-cpp/stablediffusion-pipelines-cpp.SlackBuild
@@ -0,0 +1,112 @@
+#!/bin/bash
+
+# Slackware build script for stablediffusion-pipelines-cpp
+
+# Copyright 2024 Johannes Schoepfer, Germany
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=stablediffusion-pipelines-cpp
+VERSION=${VERSION:-0.1}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "aarch64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "arm" ]; then
+ SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
+ LIBDIRSUFFIX=""
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.?z
+cd $PRGNAM-$VERSION
+
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} + -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} +
+
+export LIBTORCH_ROOTDIR=/opt/libtorch
+
+mkdir -p build
+cd build
+ unshare -n cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DOpenVINO_DIR=/usr/share/openvino/runtime/cmake \
+ -DCMAKE_BUILD_TYPE=Release ..
+ cmake --build .
+ make install/strip DESTDIR=$PKG
+cd ..
+
+mv $PKG/usr/local/* $PKG/usr
+[ "$ARCH" = "x86_64" ] && mv $PKG/usr/lib $PKG/usr/lib$LIBDIRSUFFIX
+rmdir $PKG/usr/local
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a LICENSE.txt README.md CONTRIBUTING.md $PKG/usr/doc/$PRGNAM-$VERSION
+
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/development/stablediffusion-pipelines-cpp/stablediffusion-pipelines-cpp.info b/development/stablediffusion-pipelines-cpp/stablediffusion-pipelines-cpp.info
new file mode 100644
index 0000000000..cd28bc0b71
--- /dev/null
+++ b/development/stablediffusion-pipelines-cpp/stablediffusion-pipelines-cpp.info
@@ -0,0 +1,10 @@
+PRGNAM="stablediffusion-pipelines-cpp"
+VERSION="0.1"
+HOMEPAGE="https://github.com/intel/stablediffusion-pipelines-cpp"
+DOWNLOAD="https://github.com/intel/stablediffusion-pipelines-cpp/archive/v0.1/stablediffusion-pipelines-cpp-0.1.tar.gz"
+MD5SUM="b3acd91b7202a83aeaa575c6a1dc6036"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="openvino libtorch-cxx11-abi-shared-with-deps"
+MAINTAINER="Johannes Schoepfer"
+EMAIL="slackbuilds@schoepfer.info"